/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/kyverno/kyverno/api/kyverno/v1"
)

// ImageRegistryCredentialsApplyConfiguration represents an declarative configuration of the ImageRegistryCredentials type for use
// with apply.
type ImageRegistryCredentialsApplyConfiguration struct {
	AllowInsecureRegistry *bool                                      `json:"allowInsecureRegistry,omitempty"`
	Providers             []v1.ImageRegistryCredentialsProvidersType `json:"providers,omitempty"`
	Secrets               []string                                   `json:"secrets,omitempty"`
}

// ImageRegistryCredentialsApplyConfiguration constructs an declarative configuration of the ImageRegistryCredentials type for use with
// apply.
func ImageRegistryCredentials() *ImageRegistryCredentialsApplyConfiguration {
	return &ImageRegistryCredentialsApplyConfiguration{}
}

// WithAllowInsecureRegistry sets the AllowInsecureRegistry field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the AllowInsecureRegistry field is set to the value of the last call.
func (b *ImageRegistryCredentialsApplyConfiguration) WithAllowInsecureRegistry(value bool) *ImageRegistryCredentialsApplyConfiguration {
	b.AllowInsecureRegistry = &value
	return b
}

// WithProviders adds the given value to the Providers field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Providers field.
func (b *ImageRegistryCredentialsApplyConfiguration) WithProviders(values ...v1.ImageRegistryCredentialsProvidersType) *ImageRegistryCredentialsApplyConfiguration {
	for i := range values {
		b.Providers = append(b.Providers, values[i])
	}
	return b
}

// WithSecrets adds the given value to the Secrets field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Secrets field.
func (b *ImageRegistryCredentialsApplyConfiguration) WithSecrets(values ...string) *ImageRegistryCredentialsApplyConfiguration {
	for i := range values {
		b.Secrets = append(b.Secrets, values[i])
	}
	return b
}
